diff --git a/server/tools/common/tools_util.c b/server/tools/common/tools_util.c
new file mode 100644
index 0000000..df9af9f
--- /dev/null
+++ b/server/tools/common/tools_util.c
@@ -0,0 +1,336 @@
+/*
+   SSSD
+
+   tools_utils.c
+
+   Copyright (C) Jakub Hrozek <jhrozek@redhat.com>        2009
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <talloc.h>
+#include <tevent.h>
+#include <popt.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+
+#include "util/util.h"
+#include "confdb/confdb.h"
+#include "db/sysdb.h"
+#include "tools/common/tools_util.h"
+
+/*
+ * Returns:
+ * 0 = yes, local domain proxying to files
+ * -1 = no, other type of domain
+ * > 0 = error code
+ */
+static int is_domain_local_legacy(struct tools_ctx *ctx, struct sss_domain_info *dom)
+{
+    char *libname = NULL;
+    char *conf_path = NULL;
+    int ret = -1;
+
+    /* Is there a better way to find out? Having LEGACYLOCAL as reserved would help */
+    conf_path = talloc_asprintf(ctx, "config/domains/%s", dom->name);
+    if (conf_path == NULL ) {
+        return ENOMEM;
+    }
+
+    ret = confdb_get_string(ctx->confdb, ctx, conf_path,
+                            "libName", NULL, &libname);
+    if (ret != EOK) {
+        talloc_free(conf_path);
+        return ret;
+    }
+    if (libname == NULL) {
+        talloc_free(conf_path);
+        return -1;
+    }
+
+    if (strcasecmp(libname, "files") == 0) {
+        talloc_free(conf_path);
+        talloc_free(libname);
+        return EOK;
+    }
+
+    talloc_free(conf_path);
+    talloc_free(libname);
+    return -1;
+}
+
+enum id_domain get_domain_type(struct tools_ctx *ctx,
+                               struct sss_domain_info *dom)
+{
+    if (dom == NULL) {
+        return ID_OUTSIDE;
+    }
+
+    if (strcasecmp(dom->provider, "local") == 0) {
+        return ID_IN_LOCAL;
+    } else if (strcasecmp(dom->provider, "files") == 0 ||
+               is_domain_local_legacy(ctx, dom) == 0) {
+        return ID_IN_LEGACY_LOCAL;
+    }
+
+    return ID_IN_OTHER;
+}
+
+struct sss_domain_info *get_local_domain(struct sss_domain_info *domains)
+{
+    struct sss_domain_info *dom = NULL;
+
+    /* No ID specified, find LOCAL */
+    for (dom = domains; dom; dom = dom->next) {
+        if (strcasecmp(dom->provider, "local") == 0) {
+            break;
+        }
+    }
+
+    return dom;
+}
+
+int get_domain_by_id(struct sss_domain_info *domains,
+                     uint32_t id,
+                     struct sss_domain_info **_dom)
+{
+    struct sss_domain_info *dom = NULL;
+    int ret = EOK;
+
+    if (id) {
+        for (dom = domains; dom; dom = dom->next) {
+            if (id >= dom->id_min &&
+                (dom->id_max == 0 || id <= dom->id_max)) {
+                break;
+            }
+        }
+    }
+
+    if (dom == NULL && id == 0) {
+        dom = get_local_domain(domains);
+        if (dom == NULL) {
+            DEBUG(1, ("Cannot find local domain info\n"));
+            ret = ENOENT;
+        }
+    }
+
+    *_dom = dom;
+    return ret;
+}
+
+int domain_lookup(struct ops_ctx *ops, struct sss_domain_info *domains)
+{
+    int ret;
+    struct sss_domain_info *dom = NULL;
+
+    if (!ops) {
+        return EIO;
+    }
+
+    ret = get_domain_by_id(domains, ops->uid, &dom);
+    if (ret != EOK) {
+        return ret;
+    }
+    /* If found domain by id check conflict against domain in ops */
+    if (dom && ops->domain && ops->domain != dom) {
+        return EINVAL;
+    }
+    if (ops->domain == NULL && dom) {
+        ops->domain = dom;
+    }
+
+    return EOK;
+}
+
+/*
+ * Print poptUsage as well as our error message
+ */
+void usage(poptContext pc, const char *error)
+{
+    poptPrintUsage(pc, stderr, 0);
+    if (error) fprintf(stderr, "%s", error);
+}
+
+int parse_groups(TALLOC_CTX *mem_ctx, const char *optstr, char ***_out)
+{
+    char **out;
+    char *orig, *n, *o;
+    char delim = ',';
+    unsigned int tokens = 1;
+    int i;
+
+    orig = talloc_strdup(mem_ctx, optstr);
+    if (!orig) return ENOMEM;
+
+    n = orig;
+    tokens = 1;
+    while ((n = strchr(n, delim))) {
+        n++;
+        tokens++;
+    }
+
+    out = talloc_array(mem_ctx, char *, tokens+1);
+    if (!out) {
+        talloc_free(orig);
+        return ENOMEM;
+    }
+
+    n = o = orig;
+    for (i = 0; i < tokens; i++) {
+        o = n;
+        n = strchr(n, delim);
+        if (!n) {
+            break;
+        }
+        *n = '\0';
+        n++;
+        out[i] = talloc_strdup(out, o);
+    }
+    out[tokens-1] = talloc_strdup(out, o);
+    out[tokens] = NULL;
+
+    talloc_free(orig);
+    *_out = out;
+    return EOK;
+}
+
+int parse_name_domain(struct tools_ctx *tctx,
+                      const char *fullname)
+{
+    int ret;
+    char *domain = NULL;
+    struct sss_domain_info *dom;
+
+    ret = sss_parse_name(tctx, tctx->snctx, fullname, &domain, &tctx->octx->name);
+    if (ret != EOK) {
+        DEBUG(0, ("Cannot parse full name\n"));
+        return ret;
+    }
+    DEBUG(5, ("Parsed username: %s\n", tctx->octx->name));
+
+    if (domain) {
+        DEBUG(5, ("Parsed domain: %s\n", domain));
+
+        /* Got string domain name, find corresponding sss_domain_info */
+        for (dom = tctx->domains; dom; dom = dom->next) {
+            if (strcasecmp(dom->name, domain) == 0) {
+                DEBUG(6, ("Found sss_domain_info for given domain name\n"));
+                tctx->octx->domain = dom;
+                break;
+            }
+        }
+        if (tctx->octx->domain == NULL) {
+            DEBUG(0, ("Invalid domain %s specified in FQDN\n", domain));
+            return EINVAL;
+        }
+    }
+
+    return EOK;
+}
+
+int run_command(const char *command)
+{
+    int ret;
+
+    ret = system(command);
+    if (ret != EXIT_SUCCESS) {
+        if (ret == -1) {
+            DEBUG(1, ("system(3) failed\n"));
+        } else {
+            DEBUG(1, ("Could not exec '%s', return code: %d\n",
+                      command, WEXITSTATUS(ret)));
+        }
+    }
+
+    return ret;
+}
+
+int set_locale(void)
+{
+    char *c;
+
+    c = setlocale(LC_ALL, "");
+    if (c == NULL) {
+        return EIO;
+    }
+
+    errno = 0;
+    c = bindtextdomain(PACKAGE, LOCALEDIR);
+    if (c == NULL) {
+        return errno;
+    }
+
+    errno = 0;
+    c = textdomain(PACKAGE);
+    if (c == NULL) {
+        return errno;
+    }
+
+    return EOK;
+}
+
+int init_sss_tools(struct tools_ctx **_tctx)
+{
+    int ret;
+    struct tools_ctx *tctx;
+    struct ops_ctx *octx;
+
+    tctx = talloc_zero(NULL, struct tools_ctx);
+    if (tctx == NULL) {
+        DEBUG(1, ("Could not allocate memory for tools context"));
+        return ENOMEM;
+    }
+
+    tctx->ev = tevent_context_init(tctx);
+    if (tctx->ev == NULL) {
+        DEBUG(1, ("Could not create event context"));
+        return EIO;
+    }
+
+    /* Connect to the database */
+    ret = setup_db(tctx, tctx->ev, &tctx->confdb, &tctx->sysdb);
+    if (ret != EOK) {
+        DEBUG(1, ("Could not set up database\n"));
+        goto fini;
+    }
+
+    ret = confdb_get_domains(tctx->confdb, tctx, &tctx->domains);
+    if (ret != EOK) {
+        DEBUG(1, ("Could not get domains"));
+        goto fini;
+    }
+
+    ret = sss_names_init(tctx, tctx->confdb, &tctx->snctx);
+    if (ret != EOK) {
+        DEBUG(1, ("Could not set up parsing\n"));
+        goto fini;
+    }
+
+    octx = talloc_zero(tctx, struct ops_ctx);
+    if (octx == NULL) {
+        DEBUG(1, ("Could not allocate memory for data context\n"));
+        ERROR("Out of memory\n");
+        ret = ENOMEM;
+        goto fini;
+    }
+    tctx->octx = octx;
+
+    *_tctx = tctx;
+    ret = EOK;
+fini:
+    return ret;
+}
+
diff --git a/server/tools/common/tools_util.h b/server/tools/common/tools_util.h
new file mode 100644
index 0000000..b6c413d
--- /dev/null
+++ b/server/tools/common/tools_util.h
@@ -0,0 +1,81 @@
+#ifndef __TOOLS_UTIL_H__
+#define __TOOLS_UTIL_H__
+
+#include "util/sssd-i18n.h"
+#include "tools/common/sss_sync_ops.h"
+
+#define UID_NOT_SET 0
+#define GID_NOT_SET 0
+
+#define APPEND_PARAM(str, param, val) do { \
+    if (val) { \
+        str = talloc_asprintf_append(str, param, val); \
+        if (str == NULL) { \
+            return ENOMEM; \
+        } \
+    } \
+} while(0)
+
+#define APPEND_STRING(str, val) do { \
+    str = talloc_asprintf_append(str, "%s ", val); \
+    if (str == NULL) { \
+        return ENOMEM; \
+    } \
+} while(0)
+
+#define CHECK_ROOT(val, prg_name) do { \
+    val = getuid(); \
+    if (val != 0) { \
+        DEBUG(1, ("Running under %d, must be root\n", val)); \
+        ERROR("%s must be run as root\n", prg_name); \
+        val = EXIT_FAILURE; \
+        goto fini; \
+    } \
+} while(0)
+
+enum id_domain {
+    ID_IN_LOCAL = 0,
+    ID_IN_LEGACY_LOCAL,
+    ID_IN_OTHER,
+    ID_OUTSIDE,
+    ID_ERROR
+};
+
+struct tools_ctx {
+    struct tevent_context *ev;
+    struct confdb_ctx *confdb;
+    struct sysdb_ctx *sysdb;
+
+    struct sss_names_ctx *snctx;
+    struct sss_domain_info *domains;
+
+    struct ops_ctx *octx;
+    int error;
+};
+
+int init_sss_tools(struct tools_ctx **_tctx);
+
+void usage(poptContext pc, const char *error);
+
+int parse_groups(TALLOC_CTX *mem_ctx, const char *optstr, char ***_out);
+
+struct sss_domain_info *get_local_domain(struct sss_domain_info *domains);
+
+enum id_domain get_domain_type(struct tools_ctx *ctx,
+                               struct sss_domain_info *dom);
+
+int get_domain_by_id(struct sss_domain_info *domains,
+                     uint32_t id,
+                     struct sss_domain_info **_dom);
+
+int domain_lookup(struct ops_ctx *ops,
+                  struct sss_domain_info *domains);
+
+int run_command(const char *command);
+
+int set_locale(void);
+
+int parse_name_domain(struct tools_ctx *tctx,
+                      const char *fullname);
+
+#endif  /* __TOOLS_UTIL_H__ */
diff --git a/server/tools/sss_groupadd.c b/server/tools/sss_groupadd.c
index ab313fb..c601e5c 100644
--- a/server/tools/sss_groupadd.c
+++ b/server/tools/sss_groupadd.c
@@ -28,7 +28,7 @@
 
 #include "util/util.h"
 #include "db/sysdb.h"
-#include "tools/tools_util.h"
+#include "tools/common/tools_util.h"
 
 #ifndef GROUPADD
 #define GROUPADD SHADOW_UTILS_PATH"/groupadd "
@@ -42,72 +42,6 @@
 #define GROUPADD_GROUPNAME "%s "
 #endif
 
-static void add_group_req_done(struct tevent_req *req)
-{
-    struct ops_ctx *data = tevent_req_callback_data(req, struct ops_ctx);
-
-    data->error = sysdb_transaction_commit_recv(req);
-    data->done = true;
-}
-
-static void add_group_terminate(struct ops_ctx *data, int error)
-{
-    struct tevent_req *req;
-
-    if (error != EOK) {
-        goto fail;
-    }
-
-    req = sysdb_transaction_commit_send(data, data->ev, data->handle);
-    if (!req) {
-        error = ENOMEM;
-        goto fail;
-    }
-    tevent_req_set_callback(req, add_group_req_done, data);
-
-    return;
-
-fail:
-    /* free transaction */
-    talloc_zfree(data->handle);
-
-    data->error = error;
-    data->done = true;
-}
-
-static void add_group_done(struct tevent_req *subreq);
-
-static void add_group(struct tevent_req *req)
-{
-    struct ops_ctx *data = tevent_req_callback_data(req, struct ops_ctx);
-    struct tevent_req *subreq;
-    int ret;
-
-    ret = sysdb_transaction_recv(req, data, &data->handle);
-    if (ret != EOK) {
-        return add_group_terminate(data, ret);
-    }
-
-    subreq = sysdb_add_group_send(data, data->ev, data->handle,
-                                  data->domain, data->name,
-                                  data->gid, NULL);
-    if (!subreq) {
-        add_group_terminate(data, ENOMEM);
-    }
-    tevent_req_set_callback(subreq, add_group_done, data);
-}
-
-static void add_group_done(struct tevent_req *subreq)
-{
-    struct ops_ctx *data = tevent_req_callback_data(subreq, struct ops_ctx);
-    int ret;
-
-    ret = sysdb_add_group_recv(subreq);
-    talloc_zfree(subreq);
-
-    return add_group_terminate(data, ret);
-}
-
 static int groupadd_legacy(struct ops_ctx *ctx)
 {
     int ret = EOK;
@@ -141,8 +75,7 @@ int main(int argc, const char **argv)
         POPT_TABLEEND
     };
     poptContext pc = NULL;
-    struct tevent_req *req;
-    struct ops_ctx *data = NULL;
+    struct tools_ctx *tctx = NULL;
     int ret = EXIT_SUCCESS;
     const char *pc_groupname = NULL;
 
@@ -177,7 +110,7 @@ int main(int argc, const char **argv)
 
     CHECK_ROOT(ret, debug_prg_name);
 
-    ret = init_sss_tools(&data);
+    ret = init_sss_tools(&tctx);
     if(ret != EOK) {
         DEBUG(1, ("init_sss_tools failed (%d): %s\n", ret, strerror(ret)));
         ERROR("Error initializing the tools\n");
@@ -185,20 +118,20 @@ int main(int argc, const char **argv)
         goto fini;
     }
 
-    ret = parse_name_domain(data, pc_groupname);
+    ret = parse_name_domain(tctx, pc_groupname);
     if (ret != EOK) {
         ret = EXIT_FAILURE;
         goto fini;
     }
 
-    data->gid = pc_gid;
+    tctx->octx->gid = pc_gid;
 
-    ret = domain_lookup(data);
+    ret = domain_lookup(tctx->octx,tctx->domains);
     if (ret) {
         switch (ret) {
             case EINVAL:
                 ERROR("Selected domain %s conflicts with selected GID %llu\n",
-                        data->domain->name, (unsigned long long int) data->uid);
+                        tctx->octx->domain->name, (unsigned long long int) tctx->octx->uid);
                 break;
 
             default:
@@ -209,13 +142,13 @@ int main(int argc, const char **argv)
         goto fini;
     }
 
-    ret = get_domain_type(data->ctx, data->domain);
+    ret = get_domain_type(tctx, tctx->octx->domain);
     switch (ret) {
         case ID_IN_LOCAL:
             break;
 
         case ID_IN_LEGACY_LOCAL:
-            ret = groupadd_legacy(data);
+            ret = groupadd_legacy(tctx->octx);
             if(ret != EOK) {
                 ERROR("Cannot add group to domain using the legacy tools\n");
             }
@@ -227,7 +160,7 @@ int main(int argc, const char **argv)
             goto fini;
 
         case ID_IN_OTHER:
-            DEBUG(1, ("Cannot add group to domain %s\n", data->domain->name));
+            DEBUG(1, ("Cannot add group to domain %s\n", tctx->octx->domain->name));
             ERROR("Unsupported domain type");
             ret = EXIT_FAILURE;
             goto fini;
@@ -239,22 +172,8 @@ int main(int argc, const char **argv)
             goto fini;
     }
 
-    /* add_group */
-    req = sysdb_transaction_send(data, data->ev, data->ctx->sysdb);
-    if (!req) {
-        DEBUG(1, ("Could not start transaction (%d)[%s]\n", ret, strerror(ret)));
-        ERROR("Transaction error. Could not add group.\n");
-        ret = EXIT_FAILURE;
-        goto fini;
-    }
-    tevent_req_set_callback(req, add_group, data);
-
-    while (!data->done) {
-        tevent_loop_once(data->ev);
-    }
-
-    if (data->error) {
-        ret = data->error;
+    ret = groupadd(tctx, tctx->octx);
+    if (ret) {
         switch (ret) {
             case EEXIST:
                 ERROR("A group with the same name or GID already exists\n");
@@ -271,7 +190,7 @@ int main(int argc, const char **argv)
 
     ret = EXIT_SUCCESS;
 fini:
-    talloc_free(data);
+    talloc_free(tctx);
     poptFreeContext(pc);
     exit(ret);
 }
diff --git a/server/tools/sss_groupdel.c b/server/tools/sss_groupdel.c
index 17c1bfd..efccb88 100644
--- a/server/tools/sss_groupdel.c
+++ b/server/tools/sss_groupdel.c
@@ -28,7 +28,7 @@
 
 #include "db/sysdb.h"
 #include "util/util.h"
-#include "tools/tools_util.h"
+#include "tools/common/tools_util.h"
 
 #ifndef GROUPDEL
 #define GROUPDEL SHADOW_UTILS_PATH"/groupdel "
@@ -39,79 +39,6 @@
 #endif
 
 
-static void groupdel_req_done(struct tevent_req *req)
-{
-    struct ops_ctx *data = tevent_req_callback_data(req, struct ops_ctx);
-
-    data->error = sysdb_transaction_commit_recv(req);
-    data->done = true;
-}
-
-/* sysdb callback */
-static void groupdel_done(void *pvt, int error, struct ldb_result *ignore)
-{
-    struct ops_ctx *data = talloc_get_type(pvt, struct ops_ctx);
-    struct tevent_req *req;
-
-    if (error != EOK) {
-        goto fail;
-    }
-
-    req = sysdb_transaction_commit_send(data, data->ev, data->handle);
-    if (!req) {
-        error = ENOMEM;
-        goto fail;
-    }
-    tevent_req_set_callback(req, groupdel_req_done, data);
-
-    return;
-
-fail:
-    /* free transaction */
-    talloc_zfree(data->handle);
-
-    data->error = error;
-    data->done = true;
-}
-
-static void group_del_done(struct tevent_req *subreq);
-
-static void group_del(struct tevent_req *req)
-{
-    struct ops_ctx *data = tevent_req_callback_data(req, struct ops_ctx);
-    struct tevent_req *subreq;
-    struct ldb_dn *group_dn;
-    int ret;
-
-    ret = sysdb_transaction_recv(req, data, &data->handle);
-    if (ret != EOK) {
-        return groupdel_done(data, ret, NULL);
-    }
-
-    group_dn = sysdb_group_dn(data->ctx->sysdb, data,
-                              data->domain->name, data->name);
-    if (group_dn == NULL) {
-        DEBUG(1, ("Could not construct a group DN\n"));
-        return groupdel_done(data, ENOMEM, NULL);
-    }
-
-    subreq = sysdb_delete_entry_send(data, data->ev, data->handle, group_dn, false);
-    if (!subreq)
-        return groupdel_done(data, ENOMEM, NULL);
-
-    tevent_req_set_callback(subreq, group_del_done, data);
-}
-
-static void group_del_done(struct tevent_req *subreq)
-{
-    struct ops_ctx *data = tevent_req_callback_data(subreq, struct ops_ctx);
-    int ret;
-
-    ret = sysdb_delete_entry_recv(subreq);
-
-    return groupdel_done(data, ret, NULL);
-}
-
 static int groupdel_legacy(struct ops_ctx *ctx)
 {
     int ret = EOK;
@@ -130,11 +57,10 @@ int main(int argc, const char **argv)
 {
     int ret = EXIT_SUCCESS;
     int pc_debug = 0;
-    struct ops_ctx *data = NULL;
-    struct tevent_req *req;
     struct group *grp_info;
     const char *pc_groupname = NULL;
     enum id_domain domain_type;
+    struct tools_ctx *tctx = NULL;
 
     poptContext pc = NULL;
     struct poptOption long_options[] = {
@@ -174,7 +100,7 @@ int main(int argc, const char **argv)
 
     CHECK_ROOT(ret, debug_prg_name);
 
-    ret = init_sss_tools(&data);
+    ret = init_sss_tools(&tctx);
     if(ret != EOK) {
         DEBUG(1, ("init_sss_tools failed (%d): %s\n", ret, strerror(ret)));
         ERROR("Error initializing the tools\n");
@@ -182,24 +108,24 @@ int main(int argc, const char **argv)
         goto fini;
     }
 
-    ret = parse_name_domain(data, pc_groupname);
+    ret = parse_name_domain(tctx, pc_groupname);
     if (ret != EOK) {
         ret = EXIT_FAILURE;
         goto fini;
     }
 
     /* arguments processed, go on to actual work */
-    grp_info = getgrnam(data->name);
+    grp_info = getgrnam(tctx->octx->name);
     if (grp_info) {
-        data->gid = grp_info->gr_gid;
+        tctx->octx->gid = grp_info->gr_gid;
     }
 
-    ret = domain_lookup(data);
+    ret = domain_lookup(tctx->octx,tctx->domains);
     if (ret) {
         switch (ret) {
             case EINVAL:
                 ERROR("Selected domain %s conflicts with selected GID %llu\n",
-                        data->domain->name, (unsigned long long int) data->uid);
+                        tctx->octx->domain->name, (unsigned long long int) tctx->octx->uid);
                 break;
 
             default:
@@ -210,13 +136,13 @@ int main(int argc, const char **argv)
         goto fini;
     }
 
-    domain_type = get_domain_type(data->ctx, data->domain);
+    domain_type = get_domain_type(tctx, tctx->octx->domain);
     switch (domain_type) {
         case ID_IN_LOCAL:
             break;
 
         case ID_IN_LEGACY_LOCAL:
-            ret = groupdel_legacy(data);
+            ret = groupdel_legacy(tctx->octx);
             if(ret != EOK) {
                 ERROR("Cannot delete group from domain using the legacy tools\n");
                 ret = EXIT_FAILURE;
@@ -230,7 +156,7 @@ int main(int argc, const char **argv)
             goto fini;
 
         case ID_IN_OTHER:
-            DEBUG(1, ("Cannot remove group from domain %s\n", data->domain->name));
+            DEBUG(1, ("Cannot remove group from domain %s\n", tctx->octx->domain->name));
             ERROR("Unsupported domain type\n");
             ret = EXIT_FAILURE;
             goto fini;
@@ -243,21 +169,8 @@ int main(int argc, const char **argv)
     }
 
     /* groupdel */
-    req = sysdb_transaction_send(data, data->ev, data->ctx->sysdb);
-    if (!req) {
-        DEBUG(1, ("Could not start transaction (%d)[%s]\n", ret, strerror(ret)));
-        ERROR("Transaction error. Could not remove group.\n");
-        ret = EXIT_FAILURE;
-        goto fini;
-    }
-    tevent_req_set_callback(req, group_del, data);
-
-    while (!data->done) {
-        tevent_loop_once(data->ev);
-    }
-
-    if (data->error) {
-        ret = data->error;
+    ret = groupdel(tctx, tctx->octx);
+    if (ret) {
         DEBUG(1, ("sysdb operation failed (%d)[%s]\n", ret, strerror(ret)));
         switch (ret) {
             case ENOENT:
@@ -281,7 +194,7 @@ int main(int argc, const char **argv)
     ret = EXIT_SUCCESS;
 
 fini:
-    talloc_free(data);
+    talloc_free(tctx);
     poptFreeContext(pc);
     exit(ret);
 }
